### Function

# EDataServer webdav_discover_sources_full_sync

since: 3.30

#### Declaration [src]

    gboolean
    e_webdav_discover_sources_full_sync (
      ESource* source,
      const gchar* url_use_path,
      guint32 only_supports,
      const ENamedParameters* credentials,
      EWebDAVDiscoverRefSourceFunc ref_source_func,
      gpointer ref_source_func_user_data,
      gchar** out_certificate_pem,
      GTlsCertificateFlags* out_certificate_errors,
      GSList** out_discovered_sources,
      GSList** out_calendar_user_addresses,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

This is the same as e_webdav_discover_sources_sync(), it only allows to provide a callback function (with its user_data), to reference an additional `ESource`. It’s good to avoid creating its own `ESourceRegistry` instance to get it.

Available since: 3.30

#### Parameters

`source`

  Type: `ESource`

  An `ESource` from which to take connection details.

  The data is owned by the caller of the function.

`url_use_path`

  Type: `const gchar*`

  Optional URL override, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`only_supports`

  Type: `guint32`

  Bit-or of EWebDAVDiscoverSupports, to limit what type of sources to search.

`credentials`

  Type: `ENamedParameters`

  Credentials to use for authentication to the server.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`ref_source_func`

  Type: `EWebDAVDiscoverRefSourceFunc`

  Optional callback to use to get an ESource.

  The argument can be `NULL`.

`ref_source_func_user_data`

  Type: `gpointer`

  User data for `ref_source_func`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`out_certificate_pem`

  Type: `gchar**`

  Optional return location for a server SSL certificate in PEM format, when the operation failed with an SSL error.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`out_certificate_errors`

  Type: `GTlsCertificateFlags`

  Optional `GTlsCertificateFlags`, with certificate error flags when the operation failed with SSL error.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.

`out_discovered_sources`

  Type: A list of `EWebDAVDiscoveredSource*`

  A `GSList` of all discovered sources.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.

`out_calendar_user_addresses`

  Type: A list of `utf8`

  A `GSList` of all discovered mail addresses for calendar sources.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.
  Each element is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, `FALSE` on failure.